/* XMLAttribute.java - Copyright (c) 2000 eXcelon Corporation, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of eXcelon
 * Corporation, Inc. ("Confidential Information").  You shall not disclose such
 * Confidential Information and shall use it only in accordance with the terms
 * of the license agreement you entered into with eXcelon Corporation, Inc.
 *
 * EXCELON CORP MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
 * NON-INFRINGEMENT. EXCELON SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY 
 * LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR 
 * ITS DERIVATIVES.
 */
package com.exceloncorp.XML;

public class XMLAttribute implements OutputXML
{
    //
    // Constructor(s)
    //
    XMLAttribute( String aName, String aValue ) throws com.exceloncorp.XML.XMLInvalidAttributeNameException,
                                                       com.exceloncorp.XML.XMLInvalidAttributeValueException
    {
        if ( aName != null )
        {
            if ( com.exceloncorp.XML.XMLAttributeName.isValidXMLAttributeName(aName) == true )
            {
               _name = new String(aName);
               if ( aValue != null )
               {
                   if ( com.exceloncorp.XML.XMLAttributeValue.isValidXMLAttributeValue(aValue) == true)
                   {
                      _value = new String(aValue);
                   }
                   else
                   {
                      XMLInvalidAttributeValueException e = new com.exceloncorp.XML.XMLInvalidAttributeValueException();
                      throw e;
                   }
               }
            }
            else
            {
                XMLInvalidAttributeNameException e = new com.exceloncorp.XML.XMLInvalidAttributeNameException();
                throw e;
            }
        }
    }

    //
    // Method(s)
    //
    public void print( XMLOutputStream aStream )
    {
        if ( _name != null )
        {
            aStream.add(_name + XML_ATTRIBUTE_VALUE_EQUALS + XML_ATTRIBUTE_VALUE_DELIMITER);
            if ( _value != null )
            {
                aStream.add(_value);
            }
            aStream.add(XML_ATTRIBUTE_VALUE_DELIMITER);
        }
    }
    
    protected String getName()
    {
        return _name;
    }
    
    protected void setValue( String aValue )
    {
        if ( aValue == null )
        {
            _value = null;
        }
        else
        {
            _value = new String(_value);
        }
    }

    
    //
    // Attribute(s)
    //
    String _name;
    String _value;
    
    //
    // Constant(s)
    //
    static final String XML_ATTRIBUTE_VALUE_DELIMITER = "\"";
    static final String XML_ATTRIBUTE_VALUE_EQUALS    = "=";
}
