/* XMLDocument.java - Copyright (c) 2000 eXcelon Corporation, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of eXcelon
 * Corporation, Inc. ("Confidential Information").  You shall not disclose such
 * Confidential Information and shall use it only in accordance with the terms
 * of the license agreement you entered into with eXcelon Corporation, Inc.
 *
 * EXCELON CORP MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
 * NON-INFRINGEMENT. EXCELON SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY 
 * LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR 
 * ITS DERIVATIVES.
 */
package com.exceloncorp.XML;

public class XMLDocument implements OutputXML, XMLComponent
{
   //
   // Constructor(s)
   //
   XMLDocument() throws com.exceloncorp.XML.XMLInvalidAttributeNameException,
                        com.exceloncorp.XML.XMLInvalidAttributeValueException,
                        com.exceloncorp.XML.XMLDuplicateAttributeException
   {
      _header = new XMLProcessingInstructions();
   }
   //
   // Method(s)
   //
   public void addPI( String aName )
   {
      _header.add(aName);
   }
   
   public void startTag( String aName )
   {
   }
   
   public void endTag()
   {
   }
   
   
   public void print( String aFilename )
   {
      try
      {
         XMLOutputStream output = new XMLOutputStream(aFilename);
         print( output );
         output.close();
      }
      catch(Exception e )
      {
      }
   }
   
   public void print ( XMLOutputStream aStream )
   {
//      if ( isValid() == true )
//      {
         _header.print(aStream);
         _rootTag.print(aStream);
//      }
   }
   
   public boolean isValid()
   {
      boolean returnValue = false;
      if (( _header != null ) &&
          ( _rootTag != null ))
      {
        returnValue = true;
      }
      return returnValue;
   }

   //
   // Attribute(s)
   //
   String  _name;
   XMLProcessingInstructions  _header;  // holds all processing instructions
   XMLTag                     _rootTag; // root document
   
   
   public static void main ( String[] args )
   {
      try
      {
         XMLDocument doc = new XMLDocument();
         doc.addPI("MyPI");
         doc.print("test.xml");
      }
      catch ( Exception e )
      {
        System.out.println(e);
      }
   }
}
