/* XMLProcessingInstructions.java - Copyright (c) 2000 eXcelon Corporation, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of eXcelon
 * Corporation, Inc. ("Confidential Information").  You shall not disclose such
 * Confidential Information and shall use it only in accordance with the terms
 * of the license agreement you entered into with eXcelon Corporation, Inc.
 *
 * EXCELON CORP MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
 * NON-INFRINGEMENT. EXCELON SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY 
 * LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR 
 * ITS DERIVATIVES.
 */
package com.exceloncorp.XML;

//
// Collection of all the processing instructions
//

//import com.odi.util.*;
import java.util.*;

public class XMLProcessingInstructions implements OutputXML
{
    //
    // Constructor(s)
    //
    public XMLProcessingInstructions() throws com.exceloncorp.XML.XMLInvalidAttributeNameException,
                                              com.exceloncorp.XML.XMLInvalidAttributeValueException,
                                              com.exceloncorp.XML.XMLDuplicateAttributeException
    {
        _initialInstruction = new XMLDocumentHeaderTag();
    }
    
    //
    // Method(s)
    //
    public void add ( String aName )
    {
        Vector instructions = getInstructions();
        XMLProcessingInstructionTag newTag = new XMLProcessingInstructionTag(aName);
        instructions.add(newTag);
    }
    
    public void print ( XMLOutputStream aStream )
    {
        if ( _initialInstruction != null )
        {
           _initialInstruction.print(aStream);
        }
        if ( _instructions != null )
        {
            XMLTag currentTag;
            for ( int i=0; i < _instructions.size() ; i++ )
            {
                currentTag = (XMLTag)_instructions.elementAt(i);
                currentTag.print(aStream);
            }
        }
    }
    
    private Vector getInstructions()
    {
        if ( _instructions == null )
        {
            _instructions = new Vector();
        }
        return _instructions;
    }
    
    //
    // Attribute(s)
    //
    XMLTag   _initialInstruction;  // this is normally the <?xml version="1..0".......?> tag
    Vector   _instructions;        // all the other instructions
}