package com.sonicsw.sts.java.utils;

/**
 * OSBoolean is a helper class for converting string to java boolean values and
 * vice versa.
 * 
 * @author D.J.Millman
 */

public class OSBoolean {

   /**
    * Convert the string to either true or false. If the value cannot be
    * converted then a runtime exception is thrown. For all other values other
    * than TRUE_STRING being passed in false is returned.
    * 
    * @param argValue
    *           the value to convert
    * @return the boolean value of the input string
    */
   public static boolean stringAsBoolean(String argValue) {
      boolean returnValue = false;
      if ( argValue != null )
      {
         if ( argValue.equalsIgnoreCase(TRUE_STRING) )
         {
            returnValue = true;
         }
      }
      return returnValue;
   }

   /**
    * Convert the boolean value to true or false.
    * 
    * @param argValue
    *           the value to convert from
    * @param the
    *           string representation of the boolean
    */
   public static String booleanAsString(boolean argValue) {
      String returnValue = FALSE_STRING;
      if ( argValue == true )
      {
         returnValue = TRUE_STRING;
      }
      return returnValue;
   }

   //
   // Constant(s)
   //
   public static final String TRUE_STRING          = "true";

   public static final String FALSE_STRING         = "false";

   public static final String NULL_POINTER_MESSAGE = "Cannot convert from null string to boolean type";
}