package com.sonicsw.sts.java.utils;

import java.util.Hashtable;
import java.util.Random;
import java.util.Vector;

import com.sonicsw.sts.xmlstream.XMLOutputStream;

public class OrderedAndKeyedStrings {
   //
   // Constructor(s)
   //
   public OrderedAndKeyedStrings() {
      _allowDuplicates = DEFAULT_ALLOW_DUPLICATES;
      _orderedValues = new java.util.Vector();
      _keyedValues = new java.util.Hashtable();
   }

   //
   // Method(s)
   //
   public void add(String aValue) {
      if ( aValue != null )
      {
         if ( get(aValue) == null )
         {
            String value = new String(aValue);
            _orderedValues.add(value);
            _keyedValues.put(value, value);
         }
      }
   }

   public String atIndex(int aIndex) {
      String returnValue = null;
      returnValue = (java.lang.String) _orderedValues.elementAt(aIndex);
      return returnValue;
   }

   public String get(String aKey) {
      String returnValue = null;
      if ( aKey != null )
      {
         returnValue = (java.lang.String) _keyedValues.get(aKey);
      }
      return returnValue;
   }

   public String getRandom() {
      int index = randIndex.nextInt(_orderedValues.size());
      return atIndex(index);
   }

   public int size() {
      return _orderedValues.size();
   }

   public void setCollectionTag(String aCollectionTagName) {
      if ( aCollectionTagName != null )
      {
         if ( aCollectionTagName.length() > 0 )
         {
            _collectionTag = new String(aCollectionTagName);
         }
      }
   }

   public void setValueTag(String aValueTagName) {
      if ( aValueTagName != null )
      {
         if ( aValueTagName.length() > 0 )
         {
            _valueTag = new String(aValueTagName);
         }
      }
   }

   public void toXML(XMLOutputStream aStream) throws Exception {
      if ( aStream != null )
      {
         writeStartTag(aStream);
         for (int i = 0; i < _orderedValues.size(); i++)
         {
            aStream.writeTag(null, _valueTag, null, (String) _orderedValues
                  .elementAt(i));
         }
         writeEndTag(aStream);
      }
   }

   private void writeStartTag(XMLOutputStream aStream) throws Exception {
      if ( _collectionTag != null )
      {
         aStream.startTag(_collectionTag);
      }
   }

   private void writeEndTag(XMLOutputStream aStream) throws Exception {
      if ( _collectionTag != null )
      {
         aStream.endTag();
      }
   }

   //
   // Attribute(s)
   //
   private boolean              _allowDuplicates;

   private Vector               _orderedValues;

   private Hashtable            _keyedValues;

   private String               _collectionTag;

   private String               _valueTag;

   //
   // Constant(s)
   //
   private static final boolean DEFAULT_ALLOW_DUPLICATES = false;

   private static final long    RANDOM_SEED              = 10567;

   private static Random        randIndex                = new java.util.Random(
                                                               RANDOM_SEED);
}