package com.sonicsw.sts.java.utils;

import java.util.ArrayList;
import java.util.StringTokenizer;

public class StringUtils {
	/**
	 * Predicate to determine if the the string passed in has any value.
	 * @param aValue the value to be tested
	 * @return true if the sting is not null and has 1 or more characters
	 */
	public static boolean containsInfo(String aValue) {
		boolean returnValue = false;
		if ( aValue != null )
		{
			if ( aValue.length() > ZERO_LENGTH_STRING )
			{
				returnValue = true;
			}
		}
		return returnValue;
	}
	
	/**
	 * Predicate to determine if the object passed is null or not
	 * @param aObject to be tested
	 * @return true if the object exists, false if it is null
	 */
	public static boolean assertObject(Object aObject) {
		boolean returnValue = false;
		if ( aObject != null )
		{
			returnValue = true;
		}
		return returnValue;
	}
	
	/**
	 * Given a delimited string return a collection of parameters, e.g.
	 * an input string of "a,b,c,d" will return an ArrayList with all the
	 * four values in it.
	 * @param argValues the string containing the values to parse
	 * @param argSeparator the separator
	 * @return an arraylist with the values, returns an empty collection if no values are found
	 */
	public static ArrayList get( String argValues, String argSeparator ){
		ArrayList returnValue = new ArrayList();
		if ( StringUtils.containsInfo(argValues) == true){
			StringTokenizer tokenString = new StringTokenizer(argValues,argSeparator);
			while ( tokenString.hasMoreTokens()){
				returnValue.add(tokenString.nextToken());
			}
		}
		return returnValue;
	}
	
	//
	// Constant(s)
	//
	public static final int ZERO_LENGTH_STRING = 0;
}