/*
 * XMLAttributeName.java - Copyright (c) 2000 eXcelon Corporation, Inc. All
 * Rights Reserved. This software is the confidential and proprietary
 * information of eXcelon Corporation, Inc. ("Confidential Information"). You
 * shall not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into with
 * eXcelon Corporation, Inc. EXCELON CORP MAKES NO REPRESENTATIONS OR WARRANTIES
 * ABOUT THE SUITABILITY OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. EXCELON SHALL NOT BE LIABLE FOR ANY
 * DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package com.sonicsw.sts.xmlstream;

/**
 * Manage an XMLAttributeName
 */

public class XMLAttributeName {
   //
   // Method(s)
   //

   /**
    * Predicate to test to see if the name passed in is a valid name that can be
    * used as an XML attribute name.
    * 
    * @param aName
    *           the name of the attribute to be tested
    * @return true if the name passed is valid, otherwise false is returned.
    */
   public static boolean isValidXMLAttributeName(String aName) {
      boolean returnValue = false;
      if ( aName != null )
      {
         java.util.Vector invalidValues = XMLAttributeName.invalidValues();
         int invalidValueSize = invalidValues.size();
         if ( invalidValueSize > EMPTY_INVALID_VALUES_COLLECTION )
         {
            returnValue = true;
            int currentIndex = 0;
            while ((returnValue == true) && (currentIndex < invalidValueSize))
            {
               if ( aName.indexOf((String) invalidValues
                     .elementAt(currentIndex)) != -1 )
               {
                  returnValue = false;
               }
               currentIndex++;
            }
         }
      }
      return returnValue;
   }

   /**
    * Return a list of characters that are invalid.
    * 
    * @return a vector off strings that cannot ne used within the attribute name
    */
   private static java.util.Vector invalidValues() {
      java.util.Vector returnValue = null;
      if ( _vectorInvalidValues == null )
      {
         _vectorInvalidValues = new java.util.Vector();
         _vectorInvalidValues.addElement(new String(" "));
      }
      returnValue = _vectorInvalidValues;
      return returnValue;
   }

   //
   // Constant(s)
   //
   private static java.util.Vector _vectorInvalidValues;

   private static final int        EMPTY_INVALID_VALUES_COLLECTION = 0;
}