/*
 * XMLString.java - Copyright (c) 2000 eXcelon Corporation, Inc. All Rights
 * Reserved. This software is the confidential and proprietary information of
 * eXcelon Corporation, Inc. ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in accordance
 * with the terms of the license agreement you entered into with eXcelon
 * Corporation, Inc. EXCELON CORP MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT
 * THE SUITABILITY OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT
 * LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. EXCELON SHALL NOT BE LIABLE FOR ANY
 * DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
package com.sonicsw.sts.xmlstream;

import com.sonicsw.sts.java.utils.OSString;

public class XMLString {
   public static String convertStringToXML(String aValue) {
      String returnValue = aValue;
      if ( aValue != null )
      {
         returnValue = OSString.findAndReplace(aValue, AMPERSAND_SYMBOL,
               AMPERSAND_ENTITY_REFERENCE);
         returnValue = OSString.findAndReplace(returnValue, LESS_THAN_SYMBOL,
               LESS_THAN_ENTITY_REFERENCE);
         returnValue = OSString.findAndReplace(returnValue,
               GREATER_THAN_SYMBOL, GREATER_THAN_ENTITY_REFERENCE);
         returnValue = OSString.findAndReplace(returnValue,
               SINGLE_QUOTE_SYMBOL, SINGLE_QUOTE_ENTITY_REFERENCE);
         returnValue = OSString.findAndReplace(returnValue,
               QUOTATION_MARK_SYMBOL, QUOTATION_MARK_ENTITY_REFERENCE);
      }
      return returnValue;
   }

   public static String convertXMLtoString(String aValue) {
      String returnValue = aValue;
      if ( aValue != null )
      {
         returnValue = OSString.findAndReplace(aValue,
               AMPERSAND_ENTITY_REFERENCE, AMPERSAND_SYMBOL);
         returnValue = OSString.findAndReplace(returnValue,
               LESS_THAN_ENTITY_REFERENCE, LESS_THAN_SYMBOL);
         returnValue = OSString.findAndReplace(returnValue,
               GREATER_THAN_ENTITY_REFERENCE, GREATER_THAN_SYMBOL);
         returnValue = OSString.findAndReplace(returnValue,
               SINGLE_QUOTE_ENTITY_REFERENCE, SINGLE_QUOTE_SYMBOL);
         returnValue = OSString.findAndReplace(returnValue,
               QUOTATION_MARK_ENTITY_REFERENCE, QUOTATION_MARK_SYMBOL);
      }
      return returnValue;
   }

   private static final String AMPERSAND_ENTITY_REFERENCE      = "&amp;";

   private static final String LESS_THAN_ENTITY_REFERENCE      = "&lt;";

   private static final String GREATER_THAN_ENTITY_REFERENCE   = "&gt;";

   private static final String SINGLE_QUOTE_ENTITY_REFERENCE   = "&apos;";

   private static final String QUOTATION_MARK_ENTITY_REFERENCE = "&quot;";

   private static final String AMPERSAND_SYMBOL                = "&";

   private static final String LESS_THAN_SYMBOL                = "<";

   private static final String GREATER_THAN_SYMBOL             = ">";

   private static final String SINGLE_QUOTE_SYMBOL             = "\'";

   private static final String QUOTATION_MARK_SYMBOL           = "\"";
}