package com.sonicsw.sts.xmlstream.xpath;

public interface XPath {

   /**
    * return the number of levels found in the XPath.
    * 
    * @return integer describing the number of levels.
    */
   public int levels();

   /**
    * Set the current XPath instance to be manipulated.
    * 
    * @param argXPath
    *           the XPath expression to be evaluated.
    */
   public void set(String argXPath);

   /**
    * Return the token that is found at the specified level.
    * 
    * @param argLevel
    *           the level, starting at 0 that can be specified to retrieve the
    *           information
    * @return the found expression.
    */
   public String getExpression(int argLevel);

   /**
    * Prints out the expression in string form
    * 
    * @return the expression in string form
    */
   public String toString();

   //
   // Constant(s)
   //
   public static final String XPATH_SEPARATOR = "/";
}