package com.sonicsw.sts.xmlstream.xpath;

import java.util.StringTokenizer;
import java.util.Vector;

public class XPathImpl implements XPath {

   protected XPathImpl() {
   }

   protected XPathImpl(String argXPath) {
      this.set(argXPath);
   }

   /**
    * return the number of levels found in the XPath.
    * 
    * @return integer describing the number of levels.
    */
   public int levels() {
      int returnValue = 0;
      if ( expressions_ != null )
      {
         returnValue = expressions_.size();
      }
      return returnValue;
   }

   /**
    * Set the current XPath instance to be manipulated.
    * 
    * @param argXPath
    *           the XPath expression to be evaluated.
    */
   public void set(String argXPath) {
      expression_ = argXPath;
      expressions_ = null;
      StringTokenizer tokenString = new StringTokenizer(argXPath,
            XPATH_SEPARATOR);
      expressions_ = new Vector();
      while (tokenString.hasMoreTokens() == true)
      {
         expressions_.addElement(tokenString.nextToken());
      }
   }

   /**
    * Return the token that is found at the specified level.
    * 
    * @param argLevel
    *           the level, starting at 0 that can be specified to retrieve the
    *           information
    * @return the found expression.
    */
   public String getExpression(int argLevel) {
      return (String) expressions_.elementAt(argLevel);
   }

   public String toString() {
      return expression_;
   }

   private String expression_;

   private Vector expressions_;

   public static void main(String[] args) {
      XPath query = new XPathImpl();
      query.set("/test/fred");
      for (int i = 0; i < query.levels(); i++)
      {
         System.out.println("Expression = " + query.getExpression(i));
      }
   }

}