/* XMLTag.java - Copyright (c) 2000 eXcelon Corporation, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of eXcelon
 * Corporation, Inc. ("Confidential Information").  You shall not disclose such
 * Confidential Information and shall use it only in accordance with the terms
 * of the license agreement you entered into with eXcelon Corporation, Inc.
 *
 * EXCELON CORP MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
 * NON-INFRINGEMENT. EXCELON SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY 
 * LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR 
 * ITS DERIVATIVES.
 */
package com.exceloncorp.XML;


public abstract class XMLTag extends MarkUpLanguageTag
{
    //
    // Constructor(s)
    //
    protected XMLTag()
    {
    }
    
    protected XMLTag( String aTagName )
    {
        _name = new String( aTagName );
    }
    
    protected XMLTag( String aNamespace, String aTagName )
    {
        this(aTagName);
        _namespace = new String(aNamespace);
    }
    
    //
    // Method(s)
    //
    public abstract void print( XMLOutputStream aStream );    
    protected abstract boolean isEmptyTag();
    
    protected void printAttributes( XMLOutputStream aStream )
    {
        if ( _attributes != null )
        {
            _attributes.print(aStream);
        }
    }
    
    public void addAttribute( String aName, String aValue ) throws com.exceloncorp.XML.XMLInvalidAttributeNameException,
                                                                   com.exceloncorp.XML.XMLInvalidAttributeValueException,
                                                                   com.exceloncorp.XML.XMLDuplicateAttributeException
    {
        if ( aName != null )
        {
            XMLAttributes attributes = createAttributes();
            attributes.addAttribute(aName,aValue);
        }
    }
    
    private XMLAttributes createAttributes()
    {
        if ( _attributes == null )
        {
            _attributes = new XMLAttributes();
        }
        return _attributes;
    }
        
    //
    // Attribute(s)
    //
    protected String        _name;
    protected String        _namespace;
    protected XMLAttributes _attributes;
    
    //
    // Constant(s)
    //
    
    final static String NAMESPACE_SEPARATOR = ":";
}

